<template>
    <div @dblclick="activeEdit">
        <vue-particles
                color="#fff"
                :particleOpacity="0.7"
                :particlesNumber="80"
                shapeType="circle"
                :particleSize="4"
                linesColor="#dedede"
                :linesWidth="1"
                :lineLinked="true"
                :lineOpacity="0.4"
                :linesDistance="150"
                :moveSpeed="3"
                :hoverEffect="true"
                hoverMode="grab"
                :clickEffect="true"
                clickMode="push"
        >
        </vue-particles>

        <Indicator></Indicator>
        <div class="bg" :style="{backgroundImage: 'url(' + page.imageURL + ')'}"></div>
        <div class="overlay"></div>

        <div class="homepage noselect" :class="activeEditContent || activeSignIn ? 'active': ''">
            <h1 class="title">{{page.title}}</h1>
            <div class="description">
                <ul>
                    <template v-for="(course, index) in page.courses">
                        <li :key="index">{{course.title}}</li>
                    </template>
                </ul>
            </div>
            <ul class="social-network">
                <template v-for="(social, index) in page.social_network">
                    <li :key="index">
                        <a :href="social.url"
                           class="icon "
                           :class="social.icon"
                           target="_blank"
                           v-on:mouseover="activeItem = social"
                           v-on:mouseout="activeItem = null"
                        >
                            <span class="label">{{social.title}}</span>
                        </a>
                        <div class="tooltip" v-if="activeItem === social">{{ social.title }}</div>
                    </li>
                </template>
            </ul>
            <div class="copyright">{{page.copyright}}</div>
        </div>
        <template v-if="activeEditContent && isAdmin">
            <EditContent class="editContent"
                         :class="activeEditContent ? 'active': ''"
                         @saved="getData"
                         @close="activeEditContent=false;getData"
            ></EditContent>
        </template>

        <template v-else>
            <SignIn class="editContent"
                         :class="activeSignIn ? 'active': ''"
                         @saved="getData"
                         @close="activeSignIn=false"
            ></SignIn>
        </template>

    </div>
</template>

<script>
    // @ is an alias to /src
    import EditContent from "../components/EditContent";
    import {mapState} from 'vuex'
    import SignIn from "../components/SignIn";
    import {auth} from "../plugins/firebase"
    import {eventBus} from './../utils/EventBus'
    import Indicator from "../components/Indicator";

    export default {
        name: 'home',
        components: {Indicator, SignIn, EditContent},
        data: () => ({
            counter: 0,
            activeEditContent: false,
            activeSignIn: false,
            isAdmin: false,
            activeItem: null,
        }),
        computed: {
            ...mapState([
                'page',
            ]),
        },
        mounted() {
            eventBus.$on('activeUser', () => {
                this.activeEdit();
            });
        },
        created() {
            this.getData();
        },
        methods: {
            getData() {
                if (this.activeEditContent) this.activeEditContent = false;
                this.$store.dispatch('getPage');
            },
            activeEdit() {
                const currentUser = auth.currentUser;
                if(currentUser) {
                    this.activeEditContent = !this.activeEditContent;
                    this.isAdmin = true;
                    this.activeSignIn = false;
                } else {
                    this.activeSignIn = !this.activeSignIn;
                    this.activeEditContent = false;
                    this.isAdmin = false;
                }
            }
        }
    }
</script>


<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss">
    @import url("https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,900");
    @import url("./../assets/css/fontawesome-all.min.css");
    @import "./../assets/css/homepage";
</style>
